# Beta, to be 2.0
##
# Respond v1.1.0.22 by MC_8 - Carl M. Gregory <gregory@worldinter.net>
#   beta tester, documentor & the main "idea guy" for this script:
#    bassin247 - Michael Kennedy <bassin247@eggheads.org>
#
# Please email gregory@worldinter.net for bug reports.
# Ideas/bugs/suggestions/whatever are encouraged, but please don't
#  /msg me on the IRC about it, e`mail that information.
#
# The SVS (Script Version Service) Website - http://mc.purehype.net/
##

##
# Someone says a word match in the channel, will respond to it.
# Sounds easy?  There is alot more to it than that -- but that's
# basically what it does.  Please refer to the documenation for
# extended information.
##

##
# History - too long, check out mc.respond.history
##

##
# Settings
##
#
# I will only respond to 1 *match* per x amount of seconds per user 
# (defined by @full.host).  What should x be (in seconds)?
# Seting it to 0 turns it off.
set mc_reveriable(disable) 20

# How long do you want the bot to sit idle (in min's) before doing
# a random anti idle respond?
# Seting it to 0 turns it off.
set mc_reveriable(aidle) 30

# Public respond interface (to add/remove/search/etc... this scripts
# database), what do you want the trigger to be?  
# This is the trigger for the public commands.  It goes <trigger><command>
# Don't remove the { }'s. Remember, invisable spaces do count as
# part of the trigger *wink* AND, "quote" each individual trigger.
# Replacment veriables: %botnick   (bot's nick)
#set mc_reveriable(pub_trig) { "%botnick, " "bot " "bot, " "!!" }
set mc_reveriable(pub_trig) { "%botnick " "%botnick, " "bot " "bot, " "!!" }

# What flag should the user have to access the respond interface commands?
# Flag format is "<global>|<channel>", except when you want everyone to
# have access... then set it to "".
set mc_reveriable(cmd_flgs) "oS|oS"

# This script will create it's own database to hold it's information 
# in, what do you wnat the database name to be?
set mc_reveriable(database) "~/scripts/respond.db"

# What flag should the user have to add/remove replys that perform a 
# /quote and/or /loop?  You will descover that /quotes can perform raw
# irc commands (such as op'n) and /loop can be used to loop to such a
# /quote command already setup.
# Flag format is "<global>|<channel>", except when you want everyone to
# have access... then set it to "".
set mc_reveriable(qaf) "m|"

# Do you want to strip the public text of bold/reverse/color/underline
# characters?
# Makes it a little easier to set a reply+to+record without them characters.
#  0 = No, do not strip the colors.
#  1 = Yes, please do strip the colors.
set mc_reveriable(strip) 1

# How many characters per second (cps) can your bot type?  This will make
# it look more realistic, the more the bot is to type, the longer it takes
# to display the reply.  This makes it look like the bot is acually tying
# is as opposed to a bot reply'n instantly.  Note, the higher the CPS, the
# faster it apears to be typing.
# Set the cps to 0 if you want it to reply instantly.
set mc_reveriable(cps) 7

# With soundex, the "sound" of names-- the phonetic sound to be exact, is
# coded.  This is of great help since it avoids most problems of misspell- ings
# or alternate spellings. For example Scherman, Schurman, Sherman and Shireman
# and Shurman are indexed together as the same.
# For more info, visit:  http://www.jewishgen.org/infofiles/soundex.txt
#
# Set this to the location of the soundex tcl script, relative to the bot's
# directory.  If you don't want to use a soundex script, then set this to "".
# NOTE:  One of many variations of soundex comes with this respond script, called
#        soundex.tcl
set mc_reveriable(soundex) "~/scripts/mc.soundex.tcl"


## MC SVS (Script Version Server) v1.2 ##
# Do you want the bot to connection to MC_8's SVS to see if there are newer versions
# of this script avilable?  It will only tell you -- It's up to you to get the newest
# version (I decided not to auto update the code, there may be new features in the
# newest script that may require your attention).
# 0=no/1=yes
set mc_re(svs:enabled) 1

# Once a day the script will check with the SVS -- this specifies when
# that should happen.  The setting should be the hour (military).
# examples:
#  set mc_re(svs:check) 0  ;#This is at Midnight
#  set mc_re(svs:check) 5  ;#This is at 5am
#  set mc_re(svs:check) 13  ;#This is at 1pm
#  set mc_re(svs:check) 23  ;#This is at 11pm
set mc_re(svs:check) 3

# Upon finding a newer version, who do you want to notify via note?
# Only the admin of the bot should really be worried about these notes,
# there the ones that keep everything up to par on the bots.
# Seperate each user with a " " (space).
set mc_re(svs:notify) "MC_8"

# Do you want even beta version notified to whomever you have set?  Or just
# stable releases of the script?
#  0 = Tell me about all version, even beta versions.
#  1 = Just tell me about new stable versions.
set mc_re(svs:stableonly) 0


## End of settings, the next portion is the language section.
## This will allow you to further customize the script, but
## is not nessassery for you to edit.  If it confuses you,
## just stop here, your done.
set mc_relang(0x001) "Info already exists for %array."                                ;# %array %nick
set mc_relang(0x002) "Ok %nick, set."                                                 ;# %nick
set mc_relang(0x003) "No match found, %i entries searched."                           ;# %i
set mc_relang(0x004) "1 match (out of %i entries) found for %search\; %matches"       ;# %i %search %matches
set mc_relang(0x005) "%t matches (out of %i entries) found for %search\; %matches"    ;# %t %i %search %matches
set mc_relang(0x006) "%t matches (out of %i entries) found for %search (only 25 displayed)\; %matches"
                                                                                      ;# %t %i %search %matches
set mc_relang(0x007) "%nick: %line"                                                   ;# %nick %line
set mc_relang(0x008) "Cannot add onto %array, it doesn't exist yet!"                  ;# %array
set mc_relang(0x009) "%array... it doesn't exist."                                    ;# %array
set mc_relang(0x010) "%nick, Anti-Idle information does exist."                       ;# %nick
set mc_relang(0x011) "%nick, topic contains a %cmd command.  You do not have sufficent access to do that.!"  ;# %nick %cmd




## TCL Coding starts here, no need to proceed past this point
## unless you know TCL.
set mc_re(version) v1.1.0.22
set mc_re(svs:script) "respond 001001000022"
set mc_re(svs:server) "mc.purehype.net 8085"

##
bind pubm - * mc:resp
proc mc:resp {nick uhost hand chan args} {
 global mc_re botnick mc_rebuff mc_reveriable mc_redisable mc_reaidle
 set args [join $args]
 if {$mc_reveriable(strip)} {set args [mc:re:unfilt [mc:re:strip:all [mc:re:filt $args]]]}
 if {[mc:respond:command $nick $uhost $hand $chan $args]} {return 2}
 set args [string tolower [set argup $args]]
 set uhost [string range $uhost [expr [string last @ $uhost]+1] e]
 set temp ""
 foreach array [array names mc_re] {
  if {[string match svs:* $array] || ($array == "version")} {continue}
  append temp " {[string length $array] [mc:re:filt $array]}"
 }
 foreach array [lsort -dec -real -index 0 $temp] {
  set array [join [lrange $array 1 e]]
  set channels [split [sindex $array 0] ,]
# Validate Channel
  if {$channels == "all"} {set channels [channels]}
  if {![string match "* [string tolower $chan] *" " [string tolower $channels] "]} {continue}
# Setup proper veriables
  set element [mc:re:replace [join [split [sindex $array 1] +]] "%botnick $botnick"]
  set outdata $mc_re($array)
# Evaluate element in arguments said in channel.
  set lowerelement [string tolower $element];set temp2 ""
  foreach temp [mc:re:filt $lowerelement] {
   if {[string index $temp 0] == "%"} {set temp4 *} {set temp4 $temp}
   append temp2 " $temp4"
  };set temp2 [string range $temp2 1 e]
## SOUNDEX CONVERSION
  if {$mc_reveriable(soundex) != ""} {
# Convert dup' *'s to 1 star "test********* this" -> "test* this"
   for {set i 0} {$i < [string length $temp2]} {incr i} {
    if {[string range $temp2 $i [expr $i+1]] == "**"} {
     set temp2 [string range $temp2 0 [expr $i-1]]*[string range $temp2 [expr $i+2] e]
     incr i -1;continue
    }
   }
# Convert what's said to soundex string, comply with *'s wildcard.
   set out ""
   for {set x 0;set y 0} {$x < [slength $temp2] && $y < [slength $argup]} {incr x;incr y} {
    if {[sindex $temp2 $x] == "*"} {
     if {[containstar [sindex $temp2 [expr $x+1]]]} {
      if {[string match [string tolower [sindex $temp2 [expr $x+1]]] [string tolower [sindex $argup $y]]]} {
       append out " [mc:re:str "x " [expr $y-$x]][sindex $argup $y]";incr x
      } else {incr x -1}
     } else {
      if {[string tolower [sindex $argup $y]] == [string tolower [sindex $temp2 [expr $x+1]]]} {
       append out " [mc:re:str "x " [expr $y-$x]][sindex $argup $y]";incr x
      } else {incr x -1}
     };continue
    }
    if {[containstar [sindex $temp2 $x]]} {append out " [sindex $argup $y]";continue}
    append out " [soundex [sindex $argup $y]]"
   };set sndex [string range $out 1 e]
# Repace " * " with \010.
   for {set i 0} {$i < [string length $temp2]} {incr i} {
    if {[string range " $temp2 " $i [expr $i+2]] == " * "} {
     set temp2 [string range $temp2 0 [expr $i-1]]\010[string range $temp2 [expr $i+1] e]
     incr i -1;continue
    }
   }
   set temp_out ""
   foreach word [split $temp2 \010] {append temp_out " {[mc:re:filt [soundex $word]]}"}
   set sndex_element [join [string range $temp_out 1 e] " * "]
  } {set sndex_element [mc:re:filt $temp2];set sndex $args}
  if {![string match [string tolower $sndex_element] [string tolower $sndex]]} {continue}
# Can only say the command once in x seconds...
  if {$mc_reveriable(disable)} {
   set lowerelement2 [mc:re:filt $lowerelement]
   if {[info exists "mc_redisable($lowerelement:[string tolower $chan]:$uhost)"]} {
    if {![string match "*mc_redisable([mc:re:filt [mc:re:filt $lowerelement]]:[string tolower $chan]:$uhost)*" [utimers]]} {
     utimer $mc_reveriable(disable) "catch {unset \"mc_redisable([mc:re:filt $lowerelement]:[string tolower $chan]:$uhost)\"}"
    };continue
   }
   set "mc_redisable($lowerelement:[string tolower $chan]:$uhost)" 1
   utimer $mc_reveriable(disable) "unset \"mc_redisable([mc:re:filt $lowerelement]:[string tolower $chan]:$uhost)\""
  }
# Random Response
  set temp_outdata [split [mc:re:replace $outdata "{ -OR- } {\010}"] \010]
  set a 0 ; set use_flags 0 ; set temp ""
  foreach temp_outdata2 $temp_outdata {
   if {[string match *|* [join [lindex $temp_outdata2 0]]]} {
    set temp_flags [join [lindex $temp_outdata2 0]]
    if {[string index [join [lindex $temp_outdata2 1]] 0] != "#"} {set temp_chan $chan;set temp_nochan 1} {
     set temp_nochan 2
     set temp_chan [join [lindex $temp_outdata2 1]]
    };set use_flags 1
    if {($hand == "*") && ([string match *+* $temp_flags])} {
     continue
    } elseif {$hand == "*"} {} elseif {![matchattr $hand $temp_flags $temp_chan]} {continue}
    set temp_outdata2 [lrange $temp_outdata2 $temp_nochan e]
   } ; set temp "$temp {[join $temp_outdata2]}"
  } ; set temp_outdata $temp
  if {[join $temp_outdata] == ""} {return}
  set i [llength $temp_outdata] ; set x [rand $i]
  if {$i > "1"} {
   if {![info exists mc_rebuff($array)]} {set mc_rebuff($array) $x}
   while {$mc_rebuff($array) == $x} {
    set x [rand $i]
   }
  }
  set outdata [lindex $temp_outdata $x]
  set mc_rebuff($array) $x
  set outdata [mc:re:replace $outdata "[mc:re:elementreplace $argup $element]"]
  set outdata [mc:re:replace $outdata "%nick $nick %uhost $uhost %hand $hand %chan $chan %botnick $botnick"]
# %rnick{%chan,N}
  while {[string match *%rnick\{* $outdata]} {
   foreach string [join $outdata] {
    if {[string match %rnick\{* $string]} {
     set temp_chan [string range $string 7 e]
     set temp_chan [lindex [set temp_N [split $temp_chan ,]] 0]
     set temp_N [string trim [lindex $temp_N 1] \}]
     set temp_randnick [lindex [chanlist $temp_chan] [rand [llength [chanlist $temp_chan]]]]
     set outdata [mc:re:replace $outdata "$string $temp_randnick"];break
    }
   }
  }
# %rnick
  set temp_outdata ""
  if {[string match *%rnick* $outdata]} {
   foreach string [join $outdata] {
    if {[string match %rnick $string]} {
     set temp_randnick [lindex [chanlist $chan] [rand [llength [chanlist $chan]]]]
     set temp_outdata "$temp_outdata $temp_randnick"
    } {set temp_outdata "$temp_outdata $string"}
   };set outdata [string range $temp_outdata 1 e]
  }
  set outdata [split [mc:re:replace $outdata "{ -AND- } {\020}"] \020] ;# and split
# Post it
  set oms 0
  if {![set cps [lindex [split $mc_reveriable(cps) .] 0].0]} {set cps 1}
  foreach post $outdata {
   set milliseconds [expr [lindex [split [expr ([string length $post]/$cps)*1000] .] 0]+$oms]
   switch -- [string tolower [lindex $post 0]] {
    /msg {
     if {$mc_reveriable(cps) > "0"} {
      after $milliseconds "puthelp \"PRIVMSG [mc:re:filt [join [lindex [split $post] 1]]] :[mc:re:filt [join [lrange [split $post] 2 e]]]\""
      set oms $milliseconds
     } {puthelp "PRIVMSG [lindex $post 1] :[join [lrange $post 2 e]]"}
    }
    /notice {
     if {$mc_reveriable(cps) > "0"} {
      after $milliseconds "puthelp \"NOTICE [mc:re:filt [join [lindex [split $post] 1]]] :[mc:re:filt [join [lrange [split $post] 2 e]]]\""
      set oms $milliseconds
     } {puthelp "NOTICE [lindex $post 1] :[join [lrange $post 2 e]]"}
    }
    /quote {
     after $milliseconds "puthelp \"[mc:re:filt [join [lrange [split $post] 1 e]]]\""
    }
    /me {
     if {$mc_reveriable(cps) > "0"} {
      if {[string index [lindex $post 1] 0] == "#"} {
       after $milliseconds "puthelp \"PRIVMSG [mc:re:filt [join [lindex [split $post] 1]]] :\001ACTION [mc:re:filt [join [lrange [split $post] 2 e]]]\001\""
      } {
       after $milliseconds "puthelp \"PRIVMSG [mc:re:filt $chan] :\001ACTION [mc:re:filt [join [lrange [split $post] 1 e]]]\001\""
      };set oms $milliseconds
     } {
      if {[string index [lindex $post 1] 0] == "#"} {
       puthelp "PRIVMSG [lindex $post 1] :\001ACTION [join [lrange $post 2 e]]\001"
      } {puthelp "PRIVMSG $chan :\001ACTION [join [lrange $post 1 e]]\001"}
     }
    }
    /action {
     if {$mc_reveriable(cps) > "0"} {
      if {[string index [lindex $post 1] 0] == "#"} {
       after $milliseconds "puthelp \"PRIVMSG [mc:re:filt [join [lindex [split $post] 1]]] :\001ACTION [mc:re:filt [join [lrange [split $post] 2 e]]]\001\""
      } {
       after $milliseconds "puthelp \"PRIVMSG [mc:re:filt $chan] :\001ACTION [mc:re:filt [join [lrange [split $post] 1 e]]]\001\""
      };set oms $milliseconds
     } {
      if {[string index [lindex $post 1] 0] == "#"} {
       puthelp "PRIVMSG [lindex $post 1] :\001ACTION [join [lrange $post 2 e]]\001"
      } {puthelp "PRIVMSG $chan :\001ACTION [join [lrange $post 1 e]]\001"}
     }
    }
    /loop {mc:resp $nick $uhost $hand $chan [join [lrange $post 1 e]]}
    default {
     if {$mc_reveriable(cps) > "0"} {
      after $milliseconds "puthelp \"PRIVMSG $chan :[mc:re:filt $post]\""
      set oms $milliseconds
     } {puthelp "PRIVMSG $chan :[join $post]"}
    }
   }
  } ; mc:respond:aidle:timer ; break
 }
}

##
bind ctcp - ACTION mc:resp:act
proc mc:resp:act {nick uhost hand chan key args} {
 global botnick
 if {$chan != $botnick} {
  mc:resp $nick $uhost $hand $chan "\001ACTION [join $args]\001" 
 } ; return
}

##
proc load_respond_dat {} {
 global mc_re mc_resp mc_reaidle mc_reveriable
 if {![file exists $mc_reveriable(database)]} {return 0}
 set file [open $mc_reveriable(database) "r"]
 while {![eof $file]} {
  set line [gets $file]
  if {([string index $line 0] == "#") || ([lindex $line 0] == "all")} {
   set mc_re([join [lrange [split $line] 0 1]]) [join [lrange [split $line] 2 e]]
  }
  if {[lindex $line 0] == "anti-idle"} {set mc_re(aidle) [lrange $line 1 e]}
 } ; close $file ; return 1
} ; load_respond_dat

##
proc save_respond_dat {} {
 global mc_re mc_resp mc_reaidle mc_reveriable
 set file [open $mc_reveriable(database) "w"]
 foreach line [array name mc_re] {
  if {([string index $line 0] == "#") || ([lindex $line 0] == "all")} {
   puts $file "$line $mc_re($line)"
  }
  if {$line == "aidle"} {puts $file "anti-idle $mc_re(aidle)"}
 } ; close $file ; return 1
}

##
catch {unbind pubm - * mc:respond:pub};proc mc:respond:pub {{args {}}} {}
proc mc:respond:command {nick uhost hand chan args} {
 global mc_resp mc_re botnick mc_rebuff mc_reveriable mc_redisable mc_relang
 if {![matchattr $hand $mc_reveriable(cmd_flgs) $chan] &&
     ($mc_reveriable(cmd_flgs) != "")} {return 0}
 set temp_i 1
 set args [join $args]
 foreach trig [mc:re:replace $mc_reveriable(pub_trig) "%botnick $botnick"] {
  if {[string match "$trig*" "$args"]} {set temp_i 0;break}
 };if {$temp_i} {return 0}
# Bassin %botnick in reply+to bug fix
 set args_temp [mc:re:replace $args "$trig \010"]
 set args_temp [lrange [split $args_temp \010] 1 e]
 set args [mc:re:replace [join $args_temp \010] "\010 $trig"]
# ^
 set command [lindex $args 0]
 set args [join [lrange [mc:re:filt $args] 1 e]]
 switch -exact $command {
  search {
   if {[lindex $args 0] == "anti-idle"} {
    if {![info exists mc_re(aidle)]} {
     puthelp "PRIVMSG $chan :[mc:re:replace $mc_relang(0x009) "%nick $nick %array anti-idle"]"
    } {puthelp "PRIVMSG $chan :[mc:re:replace $mc_relang(0x010) "%nick $nick"]"};return 1
   }
   set args2 *[mc:re:filt [join [join [split $args "*"]] *]]* ; set temp "" ; set i 0 ; set t 0
   foreach array [array names mc_re] {
    if {[lindex $array 0] == "anti-idle"} {continue}
    set string [lindex $array 1]
    if {[string trim $string] != ""} {
     incr i 1
     if {[string match "$args2" "$string"]} {
      set temp "$temp $array"
      incr t 1
     }
    }
   }
   if {$temp == ""} {puthelp "PRIVMSG $chan :[join [mc:re:replace $mc_relang(0x003) "%i $i"]]"} {
    set temp [split $temp]
    if {$t == "1"} {
     puthelp "PRIVMSG $chan :[join [join [mc:re:replace $mc_relang(0x004) "%i $i %search {$args} %matches {$temp}"]]]"
    } {
     if {$t >= "26"} {
      puthelp "PRIVMSG $chan :[join [join [mc:re:replace $mc_relang(0x006) "%t $t %i $i %search {$args} %matches {[lrange [split $temp] 0 24]}"]]]"
     } {
      puthelp "PRIVMSG $chan :[join [join [mc:re:replace $mc_relang(0x005) "%t $t %i $i %search {$args} %matches {$temp}"]]]"
     }
    }
   }
  }
  dsearch {
   set args2 *[mc:re:filt [join [join [split $args "*"]] *]]* ; set temp "" ; set i 0 ; set t 0
   foreach array [array names mc_re] {
    if {([sindex $array 0] == "anti-idle") ||
        ([string match svs:* $array]) || ($array == "version") ||
        ($array == "aidle")} {continue}
    incr i
    if {[string match $args2 [join $mc_re($array)]]} {append temp " $array";incr t}
   }
   if {$temp == ""} {
    puthelp "PRIVMSG $chan :[join [mc:re:replace $mc_relang(0x003) "%i $i"]]"
   } elseif {$t == "1"} {
    puthelp "PRIVMSG $chan :[join [mc:re:replace $mc_relang(0x004) "%i $i %search {$args} %matches {[split $temp]}"]]"
   } elseif {$t >= "26"} {
    puthelp "PRIVMSG $chan :[join [mc:re:replace $mc_relang(0x006) "%t $t %i $i %search {$args} %matches {[srange $temp 0 24]}"]]"
   } else {
    puthelp "PRIVMSG $chan :[join [mc:re:replace $mc_relang(0x005) "%t $t %i $i %search {$args} %matches {[split $temp]}"]]"
   };return 1
  }
  info {
   if {[sindex $args 0] == "anti-idle"} {
    if {![info exists mc_re(aidle)]} {
     puthelp "PRIVMSG $chan :[join [mc:re:replace $mc_relang(0x009) "%nick $nick %array anti-idle"]]"
    } else {
     puthelp "PRIVMSG $chan :[join [mc:re:replace $mc_relang(0x007) "%nick $nick %line {Anti-Idle $mc_re(aidle)}"]]"
    }
   } else {
    set i 0
    foreach array [array names mc_re] {
     if {([sindex $array 0] == "anti-idle") ||
         ([string match svs:* $array]) || ($array == "version") ||
         ($array == "aidle")} {continue}
     incr i
    }
    if {![info exists mc_re($args)]} {
     puthelp "PRIVMSG $chan :[mc:re:replace $mc_relang(0x003) "%i $i"]"
    } else {
     puthelp "PRIVMSG $chan :[mc:re:unfilt [mc:re:replace $mc_relang(0x007) "%nick $nick %line {[mc:re:filt [mc:re:replace $args "\\\\\\\\ \\\\\\\\\\"]] $mc_re($args)}"]]"
    }
   };return 1
  }
  add {
   if {[sindex $args 0] == "anti-idle"} {
    if {[info exists mc_re(aidle)]} {
     puthelp "PRIVMSG $chan :[join [mc:re:replace $mc_relang(0x001) "%nick $nick %array anti-idle"]]"
    } else {
     set puts [mc:re:filt [join [lrange [mc:re:filt [join $args]] 1 e]]]
     set index [string match *|* [sindex $puts 0]]
     if {(![matchattr $hand $mc_reveriable(qaf) $chan]) && ($mc_reveriable(qaf) != "")} {
      set cmd ""
      if {[lindex $puts $index] == "/quote"} {set cmd /quote}
      if {[lindex $puts $index] == "/loop"} {set cmd /loop}
      if {$cmd != ""} {
       puthelp "PRIVMSG $chan :[mc:re:replace $mc_relang(0x011) "%nick $nick %cmd $cmd"]"
       return 1
      }
     }
     set mc_re(aidle) $puts
     puthelp "PRIVMSG $chan :[mc:re:replace $mc_relang(0x002) "%nick $nick"]"
     save_respond_dat
    }
   } else {
    set array [mc:re:filt [join [lrange [mc:re:filt [join $args]] 0 1]]]
    set array_unfilt [join [lrange [mc:re:filt $args] 0 1]]
    if {[info exists mc_re($array_unfilt)]} {
     puthelp "PRIVMSG $chan :[join [mc:re:replace $mc_relang(0x001) "%nick $nick %array {$array}"]]"
    } else {
     set puts [mc:re:filt [join [lrange [mc:re:filt [join $args]] 2 e]]]
     set index [string match *|* [lindex $puts 0]]
     if {(![matchattr $hand $mc_reveriable(qaf) $chan]) && ($mc_reveriable(qaf) != "")} {
      set cmd ""
      if {[lindex $puts $index] == "/quote"} {set cmd /quote}
      if {[lindex $puts $index] == "/loop"} {set cmd /loop}
      if {$cmd != ""} {
       puthelp "PRIVMSG $chan :[mc:re:replace $mc_relang(0x011) "%nick $nick %cmd $cmd"]"
       return 1
      }
     }
     set mc_re($array_unfilt) $puts
     puthelp "PRIVMSG $chan :[mc:re:replace $mc_relang(0x002) "%nick $nick"]"
     save_respond_dat
    }
   };return 1
  }
  addor {
   if {[lindex $args 0] == "anti-idle"} {
    if {![info exists mc_re(aidle)]} {
     puthelp "PRIVMSG $chan :[join [mc:re:replace $mc_relang(0x008) "%array anti-idle"]]"
    } {
     set puts [mc:re:filt [join [lrange [mc:re:filt [join $args]] 1 e]]]
     set index [string match *|* [lindex $puts 0]]
     if {(![matchattr $hand $mc_reveriable(qaf) $chan]) && ($mc_reveriable(qaf) != "")} {
      set cmd ""
      if {[lindex $puts $index] == "/quote"} {set cmd /quote}
      if {[lindex $puts $index] == "/loop"} {set cmd /loop}
      if {$cmd != ""} {
       puthelp "PRIVMSG $chan :[join [mc:re:replace $mc_relang(0x011) "%nick $nick %cmd $cmd"]]"
       return 1
      }
     }
     set mc_re(aidle) "$mc_re(aidle) -OR- $puts"
     puthelp "PRIVMSG $chan :[join [mc:re:replace $mc_relang(0x002) "%nick $nick"]]"
     save_respond_dat
    }
   } {
    set array [mc:re:filt [join [lrange [mc:re:filt [join $args]] 0 1]]]
    set array_unfilt [join [lrange [mc:re:filt $args] 0 1]]
    if {![info exists mc_re($array_unfilt)]} {
     puthelp "PRIVMSG $chan :[join [mc:re:replace $mc_relang(0x008) "%array {$array}"]]"
    } {
     set puts [mc:re:filt [join [lrange [mc:re:filt [join $args]] 2 e]]]
     set index [string match *|* [lindex $puts 0]]
     if {(![matchattr $hand $mc_reveriable(qaf) $chan]) && ($mc_reveriable(qaf) != "")} {
      set cmd ""
      if {[lindex $puts $index] == "/quote"} {set cmd /quote}
      if {[lindex $puts $index] == "/loop"} {set cmd /loop}
      if {$cmd != ""} {
       puthelp "PRIVMSG $chan :[join [mc:re:replace $mc_relang(0x011) "%nick $nick %cmd $cmd"]]"
       return 1
      }
     }
     set mc_re($array_unfilt) "$mc_re($array_unfilt) -OR- $puts"
     puthelp "PRIVMSG $chan :[join [mc:re:replace $mc_relang(0x002) "%nick $nick"]]"
     save_respond_dat
    }
   }
  }
  del {
   if {[lindex $args 0] == "anti-idle"} {
    if {![info exists mc_re(aidle)]} {
     puthelp "PRIVMSG $chan :[join [mc:re:replace $mc_relang(0x009) "%array anti-idle"]]"
    } {
     set puts $mc_re(aidle)
     foreach puts [split [mc:re:replace $puts "{ -OR- } {\010}"] \010] {
      foreach puts [split [mc:re:replace $puts "{ -AND- } {\020}"] \020] {
       set index [string match *|* [lindex $puts 0]]
       if {(![matchattr $hand $mc_reveriable(qaf) $chan]) && ($mc_reveriable(qaf) != "")} {
        set cmd ""
        if {[lindex $puts $index] == "/quote"} {set cmd /quote}
        if {[lindex $puts $index] == "/loop"} {set cmd /loop}
        if {$cmd != ""} {
         puthelp "PRIVMSG $chan :[join [mc:re:replace $mc_relang(0x011) "%nick $nick %cmd $cmd"]]"
         return 1
        }
       }
      }
     }
     unset mc_re(aidle)
     puthelp "PRIVMSG $chan :[join [mc:re:replace $mc_relang(0x002) "%nick $nick"]]"
     save_respond_dat
    }
   } {
    set array [mc:re:filt [join [lrange [mc:re:filt [join $args]] 0 1]]]
    set array_unfilt [join [lrange [mc:re:filt $args] 0 1]]
    if {![info exists mc_re($array_unfilt)]} {
     puthelp "PRIVMSG $chan :[mc:re:replace $mc_relang(0x009) "%array {$array}"]"
    } {
     set puts $mc_re($array_unfilt)
     foreach puts [split [mc:re:replace $puts "{ -OR- } {\010}"] \010] {
      foreach puts [split [mc:re:replace $puts "{ -AND- } {\020}"] \020] {
       set index [string match *|* [lindex $puts 0]]
       if {(![matchattr $hand $mc_reveriable(qaf) $chan]) && ($mc_reveriable(qaf) != "")} {
        set cmd ""
        if {[lindex $puts $index] == "/quote"} {set cmd /quote}
        if {[lindex $puts $index] == "/loop"} {set cmd /loop}
        if {$cmd != ""} {
         puthelp "PRIVMSG $chan :[join [mc:re:replace $mc_relang(0x011) "%nick $nick %cmd $cmd"]]"
         return 1
        }
       }
      }
     }
     unset mc_re($array_unfilt)
     puthelp "PRIVMSG $chan :[mc:re:replace $mc_relang(0x002) "%nick $nick"]"
     save_respond_dat
    }
   }
  }
  delor {
   set num [lindex $args 0]
   if {[lindex $args 1] == "anti-idle"} {
    if {![info exists mc_re(aidle)]} {
     puthelp "PRIVMSG $chan :[mc:re:replace $mc_relang(0x009) "%array anti-idle"]"
    } {
     set data [split [mc:re:replace $mc_re(aidle) "{ -OR- } \010"] \010]
     set puts [lindex $data [expr $num-1]]
     foreach puts [split [mc:re:replace $puts "{ -AND- } {\020}"] \020] {
      set index [string match *|* [lindex $puts 0]]
      if {(![matchattr $hand $mc_reveriable(qaf) $chan]) && ($mc_reveriable(qaf) != "")} {
       set cmd ""
       if {[lindex $puts $index] == "/quote"} {set cmd /quote}
       if {[lindex $puts $index] == "/loop"} {set cmd /loop}
       if {$cmd != ""} {
        puthelp "PRIVMSG $chan :[join [mc:re:replace $mc_relang(0x011) "%nick $nick %cmd $cmd"]]"
        return 1
       }
      }
     }
     set data "[lrange $data 0 [expr $num-2]] [lrange $data $num e]"
     set mc_re(aidle) [join $data " -OR- "]
     puthelp "PRIVMSG $chan :[join [mc:re:replace $mc_relang(0x002) "%nick $nick"]]"
     save_respond_dat
    }
   } {
    set array [mc:re:filt [join [lrange [mc:re:filt [join $args]] 1 2]]]
    set array_unfilt [join [lrange [mc:re:filt $args] 0 1]]
    if {![info exists mc_re($array_unfilt)]} {
     puthelp "PRIVMSG $chan :[join [mc:re:replace $mc_relang(0x009) "%array {$array}"]]"
    } {
     set data [split [mc:re:replace $mc_re($array_unfilt) "{ -OR- } \010"] \010]
     set puts [lindex $data [expr $num-1]]
     foreach puts [split [mc:re:replace $puts "{ -AND- } {\020}"] \020] {
      set index [string match *|* [lindex $puts 0]]
      if {(![matchattr $hand $mc_reveriable(qaf) $chan]) && ($mc_reveriable(qaf) != "")} {
       set cmd ""
       if {[lindex $puts $index] == "/quote"} {set cmd /quote}
       if {[lindex $puts $index] == "/loop"} {set cmd /loop}
       if {$cmd != ""} {
        puthelp "PRIVMSG $chan :[join [mc:re:replace $mc_relang(0x011) "%nick $nick %cmd $cmd"]]"
        return 1
       }
      }
     }
     set data "[lrange $data 0 [expr $num-2]] [lrange $data $num e]"
     set mc_re($array_unfilt) [join $data " -OR- "]
     puthelp "PRIVMSG $chan :[join [mc:re:replace $mc_relang(0x002) "%nick $nick"]]"
     save_respond_dat
    }
   }
  }
  replace {
   if {[lindex $args 0] == "anti-idle"} {
    if {[info exists mc_re(aidle)]} {
     set puts $mc_re(aidle)
     foreach puts [split [mc:re:replace $puts "{ -OR- } {\010}"] \010] {
      foreach puts [split [mc:re:replace $puts "{ -AND- } {\020}"] \020] {
       set index [string match *|* [lindex $puts 0]]
       if {(![matchattr $hand $mc_reveriable(qaf) $chan]) && ($mc_reveriable(qaf) != "")} {
        set cmd ""
        if {[lindex $puts $index] == "/quote"} {set cmd /quote}
        if {[lindex $puts $index] == "/loop"} {set cmd /loop}
        if {$cmd != ""} {
         puthelp "PRIVMSG $chan :[join [mc:re:replace $mc_relang(0x011) "%nick $nick %cmd $cmd"]]"
         return 1
        }
       }
      }
     }
    }
    set mc_re(aidle) [mc:re:filt [join [lrange [mc:re:filt [join $args]] 1 e]]]
    puthelp "PRIVMSG $chan :[mc:re:replace $mc_relang(0x002) "%nick $nick"]"
    save_respond_dat
   } {
    set array [mc:re:filt [join [lrange [mc:re:filt [join $args]] 0 1]]]
    set array_unfilt [join [lrange [mc:re:filt $args] 0 1]]
    if {[info exists mc_re($array_unfilt)]} {
     set puts $mc_re($array_unfilt)
     foreach puts [split [mc:re:replace $puts "{ -OR- } {\010}"] \010] {
      foreach puts [split [mc:re:replace $puts "{ -AND- } {\020}"] \020] {
       set index [string match *|* [lindex $puts 0]]
       if {(![matchattr $hand $mc_reveriable(qaf) $chan]) && ($mc_reveriable(qaf) != "")} {
        set cmd ""
        if {[lindex $puts $index] == "/quote"} {set cmd /quote}
        if {[lindex $puts $index] == "/loop"} {set cmd /loop}
        if {$cmd != ""} {
         puthelp "PRIVMSG $chan :[join [mc:re:replace $mc_relang(0x011) "%nick $nick %cmd $cmd"]]"
         return 1
        }
       }
      }
     }
    }
    set mc_re($array_unfilt) [mc:re:filt [join [lrange [mc:re:filt [join $args]] 2 e]]]
    puthelp "PRIVMSG $chan :[join [mc:re:replace $mc_relang(0x002) "%nick $nick"]]"
    save_respond_dat
   }
  }
 };return 0
}

##
proc mc:respond:aidle {} {
 global mc_reaidle mc_reveriable mc_rebuff botnick mc_re
 if {!$mc_reveriable(aidle)} {return}
 if {![info exists mc_re(aidle)]} {putlog "Respond:  Time to idle, no idle information avilable." ; return}
 set outdata [split [mc:re:replace $mc_re(aidle) "{ -OR- } {\010}"] \010]
 set i [llength $outdata] ; set x [rand $i]
 if {$i != "1"} {
  if {![info exists mc_rebuff(aidle)]} {set mc_rebuff(aidle) ""}
  while {$mc_rebuff(aidle) == $x} {set x [rand $i]}
 } ;  set mc_rebuff(aidle) $x
 set outdata [split [mc:re:replace [lindex $outdata $x] "{ -AND- } {\020}"] \020]
 foreach post [mc:re:replace $outdata "%botnick $botnick"] {
  switch -- [string tolower [lindex $post 0]] {
   /msg {puthelp "PRIVMSG [lindex $post 1] :[lrange $post 2 e]"}
   /notice {puthelp "NOTICE [lindex $post 1] :[lrange $post 2 e]"}
   /quote {puthelp "[lrange $post 1 e]"}
   /me {puthelp "PRIVMSG [lindex $post 1] :\001ACTION [lrange $post 2 e]\001"}
   /action {puthelp "PRIVMSG [lindex $post 1] :\001ACTION [lrange $post 2 e]\001"}
   default {putlog "Anti-Idle'n, whatcha want me to do with\; $post"}
  }
 } ; mc:respond:aidle:timer
}

##
proc mc:respond:aidle:timer {} {
 global mc_reveriable
 if {!$mc_reveriable(aidle)} {return}
 while {[set index [lsearch [timers] *mc:respond:aidle*]] > "-1"} {
  killtimer [lindex [lindex [timers] $index] 2]
 } ; timer $mc_reveriable(aidle) mc:respond:aidle
} ; mc:respond:aidle:timer

##
proc mc:re:replace {string subs} {
 if {[llength $subs] == "1"} {set subs [lindex $subs 0]}
 for {set i 0} {[lindex $subs $i] != ""} {incr i 2} {
  regsub -all -- [lindex $subs $i] $string [lindex $subs [expr $i+1]] string
 } ; return $string
}

proc mc:re:filt {data} {
 return [join [split [join [split [join [split [join [split [join [split [join [split $data \\] \\\\] \[] \\\[] \]] \\\]] \}] \\\}] \{] \\\{] \"] \\\"]
}
proc mc:re:unfilt {data} {
 regsub -all -- \\\\\\\[ $data \[ data;regsub -all -- \\\\\\\] $data \] data;regsub -all -- \\\\\\\} $data \} data
 regsub -all -- \\\\\\\{ $data \{ data;regsub -all -- \\\\\\\" $data \" data;regsub -all -- \\\\\\\\ $data \\ data;return $data
}

proc mc:re:strip:color {ar} {
 set argument ""
 if {![string match ** $ar]} {return $ar} ; set i -1 ; set length [string length $ar]
 while {$i < $length} {
  if {[string index $ar $i] == ""} {
   set wind 1 ; set pos [expr $i+1]
   while {$wind < 3} {
    if {[string match {[0-9]} [string index $ar $pos]]} {
     incr wind 1 ; incr pos 1} {set wind 3
    }
   }
   if {([string index $ar $pos] == ",") &&
       [string match {[0-9]} [string index $ar [expr $pos + 1]]]} {
    set wind 1 ; incr pos 1
    while {$wind < 3} {
     if {[string match {[0-9]} [string index $ar $pos]]} {
      incr wind 1 ; incr pos 1} {set wind 3
     }
    }
   }
   if {$i == 0} { 
    set ar [string range $ar $pos end] 
    set length [string length $ar] 
   } { 
    set ar "[string range $ar 0 [expr $i - 1]][string range $ar $pos end]" 
    set length [string length $ar] 
   }
   set argument "$argument[string index $ar $i]"
  } {incr i 1}
 }
 set argument $ar
 return $argument
}
proc mc:re:strip:bold {ar} {return [mc:re:replace $ar " {}"]}
proc mc:re:strip:uline {ar} {return [mc:re:replace $ar " {}"]}
proc mc:re:strip:reverse {ar} {return [mc:re:replace $ar " {}"]}
proc mc:re:strip:all {ar} {
 return [mc:re:strip:reverse [mc:re:strip:uline [mc:re:strip:bold [mc:re:strip:color $ar]]]]
}

proc mc:re:str {string times} {
 if {!$times} {return ""}
 for {set buffer 1;set return ""} {$buffer <= $times} {incr buffer 1} {append return $string}
 return $return
}

proc mc:re:elementreplace {inbound element} {
 global mc_reveriable
 set i -1 ; set return ""
 set element [join [join [split $element ?*\001]]]
 set inbound [mc:re:replace $inbound "\001 {}"]
 foreach word $inbound {
  incr i 1
  if {$mc_reveriable(soundex) != ""} {
   set temp_out_1 [string tolower [soundex $word]]
   set temp_out_2 [string tolower [soundex [sindex $element $i]]]
  } {
   set temp_out_1 [string tolower $word]
   set temp_out_2 [string tolower [sindex $element $i]]
  }
  if {$temp_out_1 != $temp_out_2} {
   if {[string index [sindex $element $i] 0] == "%"} {
    append return " {[sindex $element $i]} {$word}"
   } {incr i -1}
  }
 };return [string range $return 1 e]
}

proc slength {str} {return [llength $str]}
proc sindex {str index} {return [lindex [split $str] $index]}
proc srange {str s e} {return [lrange [split $str] $s $e]}

proc isproc {proc} {
 foreach procedure [info proc] {if {$procedure == $proc} {return 1}};return 0
}

proc containstar {arg} {
 foreach string [split $arg ""] {if {$string == "*"} {return 1}};return 0
}


### Make sure all veriables are set
if {![info exists mc_reveriable(disable)]} {set mc_reveriable(disable) 0}
if {![info exists mc_reveriable(aidle)]} {set mc_reveriable(aidle) 0}
if {![info exists mc_reveriable(pub_trig)]} {set mc_reveriable(pub_trig) {}}
if {![info exists mc_reveriable(cmd_flgs)]} {set mc_reveriable(cmd_flgs) ""}
if {![info exists mc_reveriable(database)]} {set mc_reveriable(database) ".respond.db"}
if {![info exists mc_reveriable(qaf)]} {set mc_reveriable(qaf) "n|"}
if {![info exists mc_reveriable(strip)]} {set mc_reveriable(strip) 1}
if {![info exists mc_reveriable(cps)]} {set mc_reveriable(cps) 0}
if {![info exists mc_reveriable(soundex)]} {set mc_reveriable(soundex) ""}
if {![info exists mc_re(svs:enabled)]} {set mc_re(svs:enabled) 0}
if {![info exists mc_re(svs:check)]} {set mc_re(svs:check) 3}
if {![info exists mc_re(svs:notify)]} {set mc_re(svs:notify) ""}
if {![info exists mc_re(svs:stableonly)]} {set mc_re(svs:stableonly) 0}
if {![info exists mc_relang(0x001)]} {set mc_relang(0x001) "Info already exists for %array."}
if {![info exists mc_relang(0x002)]} {set mc_relang(0x002) "Ok %nick, set."}
if {![info exists mc_relang(0x003)]} {set mc_relang(0x003) "No match found, %i entries searched."}
if {![info exists mc_relang(0x004)]} {set mc_relang(0x004) "1 match (out of %i entries) found for %search\; %matches"}
if {![info exists mc_relang(0x005)]} {set mc_relang(0x005) "%t matches (out of %i entries) found for %search\; %matches"}
if {![info exists mc_relang(0x006)]} {set mc_relang(0x006) "%t matches (out of %i entries) found for %search (only 25 displayed)\; %matches"}
if {![info exists mc_relang(0x007)]} {set mc_relang(0x007) "%nick: %line"}
if {![info exists mc_relang(0x008)]} {set mc_relang(0x008) "Cannot add onto %array, it doesn't exist yet!"}
if {![info exists mc_relang(0x009)]} {set mc_relang(0x009) "%array... it doesn't exist."}
if {![info exists mc_relang(0x010)]} {set mc_relang(0x010) "%nick, Anti-Idle information does exist."}
if {![info exists mc_relang(0x011)]} {set mc_relang(0x011) "%nick, topic contains a %cmd command.  You do not have sufficent access to do that!"}


## Load soundex support.
if {$mc_reveriable(soundex) != ""} {
 if {[catch {source $mc_reveriable(soundex)} error]} {
  putlog "Respond $mc_re(version): Soundex support load problem (disabling soundex);"
  foreach line [split $error \n] {putlog "    $line"}
  set mc_reveriable(soundex) ""
 } elseif {![isproc soundex]} {
  putlog "Respond $mc_re(version): Soundex support load problem (disabling soundex);"
  putlog "    $mc_reveriable(soundex) does not support the soundex 'proc'edure."
  set mc_reveriable(soundex) ""
 } elseif {[catch {soundex "soundex procedure test"} spt]} {
  putlog "Respond $mc_re(version): Soundex support load problem (disabling soundex);"
  putlog "    $mc_reveriable(soundex) returned an error when performing inital test:"
  putlog "     set temp \[soundex \"soundex procedure test\"\]"
  foreach line [split $spt \n] {putlog "     $line"}
  set mc_reveriable(soundex) ""
 } {
  putlog "Respond $mc_re(version): Soundex support loaded."
  foreach line [split $error \n] {putlog "    $line"}
 }
}

if {$mc_re(svs:enabled)} {
 if {($mc_re(svs:check) > "23") || ($mc_re(svs:check) < "0")} {set mc_re(svs:check) 00}
 if {[string length $mc_re(svs:check)] == "1"} {set mc_re(svs:check) 0$mc_re(svs:check)}
 if {$mc_re(svs:stableonly)} {
  set mc_re(svs:script) [string range $mc_re(svs:script) 0 [expr [string length $mc_re(svs:script)]-4]]999
 }
 catch {unbind time - "00 $mc_re(svs:oldcheck) * * *" mc:re:svs:time}
 set mc_re(svs:oldcheck) $mc_re(svs:check)
 bind time - "00 $mc_re(svs:check) * * *" mc:re:svs:time
 proc mc:re:svs:time {min hour day month year} {
  global mc_re
  catch {control [connect [lindex $mc_re(svs:server) 0] [lindex $mc_re(svs:server) 1]] mc:re:svs:interface}
 }
}
proc mc:re:svs:interface {idx args} {
 global mc_re;set args [join $args]
 switch -- [lindex $args 0] {
  "" {return 1}
  000 {putdcc $idx q}
  002 {putdcc $idx [lindex $mc_re(svs:script) 0]}
  003 {
   set args [lrange $args 1 e]
   if {[lindex $args 0] != [lindex $mc_re(svs:script) 0]} {return 0}
   putdcc $idx q
   if {[lindex $args 1] > [lindex $mc_re(svs:script) 1]} {
    set note [mc:re:svs:replace [lindex $args 7] "%0 {[lindex $args 0]} %1 {[lindex $args 1]} %2 {[lindex $args 2]}"]
    set note [mc:re:svs:replace $note "%3 {[lindex $args 3]} %4 {[lindex $args 4]} %5 {[lindex $args 5]}"]
    set note [mc:re:svs:replace $note "%6 {[lindex $args 6]} %8 {[lindex $args 8]} %version {$mc_re(version)}"]
    set note [mc:re:svs:replace $note "%9 {[lindex $args 9]} %10 {[lindex $args 10]} %11 {[lindex $args 11]}"]
    set note [mc:re:svs:replace $note "%12 {[lindex $args 12]} %13 {[lindex $args 13]} %14 {[lindex $args 14]}"]
    set note [mc:re:svs:replace $note "%15 {[lindex $args 15]} %16 {[lindex $args 16]} %17 {[lindex $args 17]}"]
    set note [mc:re:svs:replace $note "%18 {[lindex $args 18]} %19 {[lindex $args 19]} %20 {[lindex $args 20]}"]
    foreach notify [join [split $mc_re(svs:notify) ",;"]] {
     set outnote [mc:re:svs:replace $note "%nick {$notify}"]
     if {[string match "*$outnote*" "[notes $notify -[notes $notify]]"]} {
      set cont 0
      foreach unote [notes $notify -[notes $notify]] {
       if {$outnote == [lindex $unote 2]} {set cont 1;break}
      };if {$cont} {continue}
     }
     switch -- [sendnote SVS $notify $outnote] {
      0 {putlog "MC SVS for [lindex $mc_re(svs:script) 0] had some errors updating $notify on current version of script; unknown reason!"}
      3 {putlog "MC SVS for [lindex $mc_re(svs:script) 0] had some errors updating $notify on current version of script; notebox too full!"}
     }
    }
   }
  }
 };return 0
}
proc mc:re:svs:replace {string subs} {
 if {[llength $subs] == "1"} {set subs [lindex $subs 0]}
 for {set i 0} {[lindex $subs $i] != ""} {incr i 2} {
  regsub -all -- [lindex $subs $i] $string [lindex $subs [expr $i+1]] string
 } ; return $string
}

putlog "Respond $mc_re(version) by MC_8 loaded."

##
# MC_8's scratch pad of code.  (keeping so I don't forget how it was done)
##
#[23:09] <MC_8> .tcl set search "*hey*dude*%what* %subject" ; set words "hey dude man, sup?"
#[23:09] <Mute> Tcl: hey dude man, sup?
#[23:09] <MC_8> .tcl set i -1 ; set search [split [join $search "*"] "*"] ; set src $search ; set search "" ; foreach srch $src {if {$srch != ""} {set search "$search $srch"}} ; foreach word $words {incr i 1 ; putlog "\[$i\][lindex $search $i] ? $word" ; if {$word != [lindex $search $i]} {if {[string index [lindex $search $i] 0] == "%"} {putlog "[lindex $search $i] == $word"} {incr i -1}}}
#[23:09] <Mute> [21:11] [0]hey ? hey
#[23:09] <Mute> [21:11] [1]dude ? dude
#[23:09] <Mute> [21:11] [2]%what ? man,
#[23:09] <Mute> [21:11] %what == man,
#[23:09] <Mute> [21:11] [3]%subject ? sup?
#[23:09] <Mute> [21:11] %subject == sup?
##